%%By Chris Dancy, Assistant professor in Computer Science @ Bucknell University
%%To do - Make a 3-d matrix in place of count variables (e.g.,
%%aCountAfterLossBad)
function retVal = AnalyzeBehavior(wildCard, dirName, numBlocks)
    pattern = fullfile(dirName, wildCard);
    files = dir(pattern);
    retVal = {};
    
    
    %Use NumBlocks
    countSkip = 0;
    skipMat = [];
    for i=1:length(files)
        fileID = fopen(fullfile(dirName, files(i).name));
        files(i).name
        if( str2double(files(i).name(5:end-4)) < 7 )
            continue;
        end
        
        if (strcmpi(files(i).name(1), 'm'))
            sex = 1;
        else
            sex = 2;
        end
        
        if( str2double(files(i).name(3)) == 1 )
            groupName = 'Negative';
        elseif( str2double(files(i).name(3)) == 2 )
            groupName = 'Neutral';
        else
            groupName = 'Positive';
        end
        
        headerLine = fgetl(fileID);
        data = textscan(fileID, '%d\t%f\t%f\t%d\t%d\t%d\t%d\t%d\n');
        dSel = data{4};
        dRespTime = data{3};
        tempCountSkipArr = dRespTime > 3.4;
        tempCountSkipArr(tempCountSkipArr) = [];
        if( numel(tempCountSkipArr) > 80 )
            countSkip = 100 - numel(tempCountSkipArr) + countSkip;
            skipPos = zeros((100-numel(tempCountSkipArr)), 2);
            skipPos(:,2) = find(dRespTime > 3.4);
        else
            skipPos = zeros(100, 2);
            skipPos(:,2) = 1:100;
        end
        skipPos(:,1) = str2double(files(i).name(5:end-4));
        skipMat = [skipMat; skipPos];
        totalMon = data{6} - data{8};
        trialMon = data{5} - data{7};
        
        cumulSum = 0;
        avgResp = NaN;
        firstDeck = 0;
        
        for j=1:numBlocks
            
            if (numel(tempCountSkipArr) <= 80)
                continue;
            end
            
            tempSel = dSel(1+((j-1)*100/numBlocks):j*100/numBlocks);
            tempResp = dRespTime(1+((j-1)*100/numBlocks):j*100/numBlocks);
            respCorr = tempResp <= 3.4;
            tempSel = tempSel(respCorr);
            tempResp = tempResp(respCorr);
            tempTotalMon = totalMon(1+((j-1)*100/numBlocks):j*100/numBlocks);
            tempTotalMon = tempTotalMon(respCorr);
            tempTrialMon = trialMon(1+((j-1)*100/numBlocks):j*100/numBlocks);
            tempTrialMon = tempTrialMon(respCorr);        
            
            aRateABCD = 0;
            aRateGoodBad = 0;
            aRateBadGood = 0;
            aRateWithin = 0;
            aCountAfterLossGood = 0;
            aCountAfterLossBad = 0;
            bCountAfterLossGood = 0;
            bCountAfterLossBad = 0;
            cCountAfterLossGood = 0;
            cCountAfterLossBad = 0;
            dCountAfterLossGood = 0;
            dCountAfterLossBad = 0;
            aCountAfterWinGood = 0;
            aCountAfterWinBad = 0;
            bCountAfterWinGood = 0;
            bCountAfterWinBad = 0;
            cCountAfterWinGood = 0;
            cCountAfterWinBad = 0;
            dCountAfterWinGood = 0;
            dCountAfterWinBad = 0;
            repeatCountAfterLoss = 0;
            aRepeatAfterLoss = 0;
            bRepeatAfterLoss = 0;
            cRepeatAfterLoss = 0;
            dRepeatAfterLoss = 0;
            repeatCountAfterWin = 0;
            aRepeatAfterWin = 0;
            bRepeatAfterWin = 0;
            cRepeatAfterWin = 0;
            dRepeatAfterWin = 0;
            
            
            %Find number of times switching between decks (any deck and advantageous and
            %disadvantageous decks)
            %Also get counts of deck selections after receiving a loss or
            %gain
            for k=1:numel(tempSel)
                
                if (k+1 <= numel(tempSel))
                    currDeck = tempSel(k);
                    
                    %get participant's first deck selection
                    if( firstDeck == 0 )
                        firstDeck = currDeck;
                    end
                    
                    if (currDeck ~= tempSel(k+1))
                        aRateABCD = aRateABCD + 1;
                        
                        if (tempTrialMon(k) > 0)
                            if (currDeck > 2)
                                switch tempSel(k+1)
                                    case 1
                                        aCountAfterWinGood = aCountAfterWinGood + 1;
                                    case 2
                                        bCountAfterWinGood = bCountAfterWinGood + 1;
                                    case 3
                                        cCountAfterWinGood = cCountAfterWinGood + 1;
                                    case 4
                                        dCountAfterWinGood = dCountAfterWinGood + 1;
                                end
                            else
                                switch tempSel(k+1)
                                    case 1
                                        aCountAfterWinBad = aCountAfterWinBad + 1;
                                    case 2
                                        bCountAfterWinBad = bCountAfterWinBad + 1;
                                    case 3
                                        cCountAfterWinBad = cCountAfterWinBad + 1;
                                    case 4
                                        dCountAfterWinBad = dCountAfterWinBad + 1;
                                end
                            end
                        else
                            
                            if (currDeck > 2)
                                switch tempSel(k+1)
                                    case 1
                                        aCountAfterLossGood = aCountAfterLossGood + 1;
                                    case 2
                                        bCountAfterLossGood = bCountAfterLossGood + 1;
                                    case 3
                                        cCountAfterLossGood = cCountAfterLossGood + 1;
                                    case 4
                                        dCountAfterLossGood = dCountAfterLossGood + 1;
                                end
                            else
                                switch tempSel(k+1)
                                    case 1
                                        aCountAfterLossBad = aCountAfterLossBad + 1;
                                    case 2
                                        bCountAfterLossBad = bCountAfterLossBad + 1;
                                    case 3
                                        cCountAfterLossBad = cCountAfterLossBad + 1;
                                    case 4
                                        dCountAfterLossBad = dCountAfterLossBad + 1;
                                end
                            end
                        end
                        
                    else
                        
                        if (tempTrialMon(k) > 0)
                            switch currDeck
                                case 1
                                    aRepeatAfterWin = aRepeatAfterWin + 1;
                                case 2
                                    bRepeatAfterWin = bRepeatAfterWin + 1;
                                case 3
                                    cRepeatAfterWin = cRepeatAfterWin + 1;
                                case 4
                                    dRepeatAfterWin = dRepeatAfterWin + 1;
                            end
                            repeatCountAfterWin = repeatCountAfterWin + 1;
                        else
                            switch currDeck
                                case 1
                                    aRepeatAfterLoss = aRepeatAfterLoss + 1;
                                case 2
                                    bRepeatAfterLoss = bRepeatAfterLoss + 1;
                                case 3
                                    cRepeatAfterLoss = cRepeatAfterLoss + 1;
                                case 4
                                    dRepeatAfterLoss = dRepeatAfterLoss + 1;
                            end
                            repeatCountAfterLoss = repeatCountAfterLoss + 1;
                        end
                    end
                    
                    if (currDeck <= 2 && tempSel(k+1) > 2)
                        aRateBadGood = aRateBadGood + 1;
                    elseif (currDeck > 2 && tempSel(k+1) <= 2)
                        aRateGoodBad = aRateGoodBad + 1;
                    elseif (currDeck > 2 && tempSel(k+1) > 2 || ...
                            currDeck <= 2 && tempSel(k+1) <= 2)
                        aRateWithin = aRateWithin + 1;
                    end
                end
            end
            
            d1 = tempSel == 1;
            d2 = tempSel == 2;
            d3 = tempSel == 3;
            d4 = tempSel == 4;
            d1NegMon = (tempTotalMon < 0) & (tempSel == 1);
            d1PosMon = (tempTotalMon >= 0) & (tempSel == 1);
            d2NegMon = (tempTotalMon < 0) & (tempSel == 2);
            d2PosMon = (tempTotalMon >= 0) & (tempSel == 2);
            d3NegMon = (tempTotalMon < 0) & (tempSel == 3);
            d3PosMon = (tempTotalMon >= 0) & (tempSel == 3);
            d4NegMon = (tempTotalMon < 0) & (tempSel == 4);
            d4PosMon = (tempTotalMon >= 0) & (tempSel == 4);
            d1RespMean = nanmean(tempResp(d1));
            d2RespMean = nanmean(tempResp(d2));
            d3RespMean = nanmean(tempResp(d3));
            d4RespMean = nanmean(tempResp(d4));
            goodRespMean = nanmean([d3RespMean d4RespMean], 2);
            badRespMean = nanmean([d1RespMean d2RespMean], 2);
            totalRespMean = nanmean([goodRespMean badRespMean], 2);
            avgResp = nanmean([totalRespMean avgResp], 2);
            numD1 = numel(tempSel(d1));
            numD2 = numel(tempSel(d2));
            numD3 = numel(tempSel(d3));
            numD4 = numel(tempSel(d4));
            numGood = numD4 + numD3;
            numBad = numD1 + numD2;
            score = numGood - numBad;
            cumulSum = cumulSum + score;
            numGoodNegMon = numel(tempSel(d3NegMon)) + numel(tempSel(d4NegMon));
            numGoodPosMon = numel(tempSel(d3PosMon)) + numel(tempSel(d4PosMon));
            numBadNegMon = numel(tempSel(d1NegMon)) + numel(tempSel(d2NegMon));
            numBadPosMon = numel(tempSel(d1PosMon)) + numel(tempSel(d2PosMon));
            totalNegMon = numGoodNegMon - numBadNegMon;
            totalPosMon = numGoodPosMon - numBadPosMon;
            
            reRate = (numel(tempSel) - (aRateABCD)) / numel(tempSel);
            aRateABCD = aRateABCD/numel(tempSel);
            aRateBadGood = aRateBadGood/numel(tempSel);
            aRateGoodBad = aRateGoodBad/numel(tempSel);
            aRateWithin = aRateWithin / numel(tempSel);
            aCountAfterLossGood = aCountAfterLossGood / numel(tempSel(tempTrialMon <= 0 & (tempSel == 3 | tempSel == 4)));
            aCountAfterLossBad = aCountAfterLossBad / numel(tempSel(tempTrialMon <= 0 & (tempSel == 1 | tempSel == 2)));
            bCountAfterLossGood = bCountAfterLossGood / numel(tempSel(tempTrialMon <= 0 & (tempSel == 3 | tempSel == 4)));
            bCountAfterLossBad = bCountAfterLossBad / numel(tempSel(tempTrialMon <= 0 & (tempSel == 1 | tempSel == 2)));
            cCountAfterLossGood = cCountAfterLossGood / numel(tempSel(tempTrialMon <= 0 & (tempSel == 3 | tempSel == 4)));
            cCountAfterLossBad = cCountAfterLossBad / numel(tempSel(tempTrialMon <= 0 & (tempSel == 1 | tempSel == 2)));
            dCountAfterLossGood = dCountAfterLossGood / numel(tempSel(tempTrialMon <= 0 & (tempSel == 3 | tempSel == 4)));
            dCountAfterLossBad = dCountAfterLossBad / numel(tempSel(tempTrialMon <= 0 & (tempSel == 1 | tempSel == 2)));
            aCountAfterWinGood = aCountAfterWinGood / numel(tempSel(tempTrialMon > 0 & (tempSel == 3 | tempSel == 4)));
            aCountAfterWinBad = aCountAfterWinBad / numel(tempSel(tempTrialMon > 0 & (tempSel == 1 | tempSel == 2)));
            bCountAfterWinGood = bCountAfterWinGood / numel(tempSel(tempTrialMon > 0 & (tempSel == 3 | tempSel == 4)));
            bCountAfterWinBad = bCountAfterWinBad / numel(tempSel(tempTrialMon > 0 & (tempSel == 1 | tempSel == 2)));
            cCountAfterWinGood = cCountAfterWinGood / numel(tempSel(tempTrialMon > 0 & (tempSel == 3 | tempSel == 4)));
            cCountAfterWinBad = cCountAfterWinBad / numel(tempSel(tempTrialMon > 0 & (tempSel == 1 | tempSel == 2)));
            dCountAfterWinGood = dCountAfterWinGood / numel(tempSel(tempTrialMon > 0 & (tempSel == 3 | tempSel == 4)));
            dCountAfterWinBad = dCountAfterWinBad / numel(tempSel(tempTrialMon > 0 & (tempSel == 1 | tempSel == 2)));
            repeatCountAfterLoss = repeatCountAfterLoss / numel(tempSel(tempTrialMon <= 0));
            aRepeatAfterLoss = aRepeatAfterLoss / numel(tempSel(tempTrialMon <= 0 & tempSel == 1));
            bRepeatAfterLoss = bRepeatAfterLoss / numel(tempSel(tempTrialMon <= 0 & tempSel == 2));
            cRepeatAfterLoss = cRepeatAfterLoss / numel(tempSel(tempTrialMon <= 0 & tempSel == 3));
            dRepeatAfterLoss = dRepeatAfterLoss / numel(tempSel(tempTrialMon <= 0 & tempSel == 4));
            repeatCountAfterWin = repeatCountAfterWin / numel(tempSel(tempTrialMon > 0));
            aRepeatAfterWin = aRepeatAfterWin / numel(tempSel(tempTrialMon > 0 & tempSel == 1));
            bRepeatAfterWin = bRepeatAfterWin / numel(tempSel(tempTrialMon > 0 & tempSel == 2));
            cRepeatAfterWin = cRepeatAfterWin / numel(tempSel(tempTrialMon > 0 & tempSel == 3));
            dRepeatAfterWin = dRepeatAfterWin / numel(tempSel(tempTrialMon > 0 & tempSel == 4));
            
            numel(tempSel(tempTrialMon > 0 & tempSel == 2))
            numel(tempSel(tempTrialMon <= 0 & tempSel == 2))
            
            %retVal = {'sid', 'group', 'sex', 'block',  'A.Response.Time', 'B.Response.Time', ...
            %'C.Response.Time', 'D.Response.Time', 'A', 'B', 'C', 'D'};
            
            retVal = [retVal; {str2double(files(i).name(5:end-4)) str2double(files(i).name(3)) ...
                sex j d1RespMean d2RespMean d3RespMean d4RespMean goodRespMean badRespMean ...
                totalRespMean numD1 numD2 numD3 numD4 numGood numBad score numel(tempSel(d1NegMon)) ...
                numel(tempSel(d2NegMon)) numel(tempSel(d3NegMon)) numel(tempSel(d4NegMon)) ...
                numel(tempSel(d1PosMon)) numel(tempSel(d2PosMon)) numel(tempSel(d3PosMon)) ...
                numel(tempSel(d4PosMon)) numGoodNegMon numBadNegMon numGoodPosMon numBadPosMon ...
                totalNegMon totalPosMon cumulSum avgResp aRateABCD aRateBadGood aRateGoodBad aRateWithin reRate ...
                str2double(files(i).name(3)) log(totalRespMean) log(badRespMean) log(goodRespMean) ...
                repeatCountAfterLoss repeatCountAfterWin aRepeatAfterLoss aRepeatAfterWin ...
                bRepeatAfterLoss bRepeatAfterWin cRepeatAfterLoss cRepeatAfterWin ...
                dRepeatAfterLoss dRepeatAfterWin ...
                aCountAfterLossBad aCountAfterLossGood aCountAfterWinBad aCountAfterWinGood ...
                bCountAfterLossBad bCountAfterLossGood bCountAfterWinBad bCountAfterWinGood ...
                cCountAfterLossBad cCountAfterLossGood cCountAfterWinBad cCountAfterWinGood ...
                dCountAfterLossBad dCountAfterLossGood dCountAfterWinBad dCountAfterWinGood firstDeck}];
        end
        fclose(fileID);
    end
    csvwrite('BehTrialsSkipped.csv', skipMat);
    csvwrite('BehAnalyzed.csv', retVal);
    %Put CSVWrite for behavioral data file here
end

