function Calibrate(wPtr)
    %Wait for initial release of keys
    while KbCheck; end
    
    screenSize = Screen('Resolution', wPtr);
    
    %CalibrateEyeAngle(wPtr, screenSize);
    CalibratePOR(wPtr, screenSize);
    
end

function CalibratePOR(wPtr, screenSize)
    ShowCursor('CrossHair');
    sizeOffset = 10;
    centerH = (screenSize.width/2);
    centerV = (screenSize.height/2);
    tLH = (screenSize.width/4);
    tLV = (screenSize.height/4);
    tRH = (screenSize.width/1.333);
    tRV = (screenSize.height/4);
    bLH = (screenSize.width/4);
    bLV = (screenSize.height/1.333);
    bRH = (screenSize.width/1.333);
    bRV = (screenSize.height/1.333);
    Screen('FillRect', wPtr, [255 255 255]);
    Screen('FillOval', wPtr, [0 0 0], [(centerH-sizeOffset) (centerV-sizeOffset) (centerH+sizeOffset) (centerV+sizeOffset)]);
    Screen('FillOval', wPtr, [0 0 0], [(tLH-sizeOffset) (tLV-sizeOffset) (tLH+sizeOffset) (tLV+sizeOffset)]);
    Screen('FillOval', wPtr, [0 0 0], [(tRH-sizeOffset) (tRV-sizeOffset) (tRH+sizeOffset) (tRV+sizeOffset)]);
    Screen('FillOval', wPtr, [0 0 0], [(bLH-sizeOffset) (bLV-sizeOffset) (bLH+sizeOffset) (bLV+sizeOffset)]);
    Screen('FillOval', wPtr, [0 0 0], [(bRH-sizeOffset) (bRV-sizeOffset) (bRH+sizeOffset) (bRV+sizeOffset)]);
    Screen('Flip', wPtr);
    while 1
        [isDown, secs, code] = KbCheck;    
        if( length(find(code)) ~= 1 ), continue;
        elseif( isDown && strcmpi(KbName(code), 'e') ), break;
        end 
    end
    
    HideCursor();
end

