%Use to summarize output from processEDA into data that are more easily
%analyzed
%For each block or trial:
%sid, blockNum, trialNum (if trial), (1)CDA-SCR, CDA-nSCR, CDA-Lat,
%CDA-AmpSum, TTP-nSCR, TTP-Lat, TTP-AmpSum, Global-SCR ....   (1) - This
%is recorded for each of the 3 stages of a trial and seperated based on
%good or bad deck choice
function SummarizeEDA(dirName, behDirName, newFileName, currFileName, numBlocks)
    currFid = fopen(fullfile(dirName, currFileName));
    
    behFiles = dir(fullfile(behDirName, '*.txt'));
    
    edaMat = textscan(currFid, '%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f');
    edaMat = cell2mat(edaMat);
    
    currBlock = 0;
    currTrial = 0;
    currSID = 0;
    numPerBlock = 100 / numBlocks;
    currGroup = 0;
    
    newEDABlockMat = [];
    
    skipMat = csvread('C:\Users\Christopher\Dropbox\Grad\Experiments\Behavioral\Software\Matlab_Psychotoolbox\IGT_Psychotoolbox\DACode\BehTrialsSkipped.csv');
    
    rewLossVec = zeros(length(edaMat(:,1)),1);
    skipVec = zeros(length(edaMat(:,1)),1);
    
    for i=1:length(edaMat(:,1))
        
        %If we're at a new participant
        if( currSID == 0 || currSID ~= edaMat(i,1) )
            currSID = edaMat(i,1);
            currSex = edaMat(i,2);
            currGroup = edaMat(i,3);
            currBlock = 0;
            currTrial = 0;
            startInd = i;
            %Find behavioral file (used for to mark some of the trials)
            for j=1:length(behFiles)
                if( str2double(behFiles(j).name(5:end-4)) == currSID )
                    behFileID = fopen(fullfile('..\subjs', behFiles(j).name));
                    behData = textscan(behFileID, '%d\t%f\t%f\t%d\t%d\t%d\t%d\t%d\n', 'HeaderLines', 1);
                    losses = behData{7};
                    fclose(behFileID);
                end
            end
        end
        
        tempSkipMat = skipMat(:,1) == currSID;
        testSkipMatEmpty = tempSkipMat(tempSkipMat);
        
        if( ~isempty(testSkipMatEmpty) && currTrial ~= 0 )
            findTrial = find(skipMat(tempSkipMat,2) == currTrial,1);
            if( ~isempty(findTrial) )
                disp(strcat('skipping trial ', num2str(currTrial), ' for user ', num2str(currSID), '!'));
                skipVec(i) = 1;
                if( mod(i, 3) == 0 )
                    currTrial = currTrial+1;
                end
                if( mod(i, 3) == 0 && (currBlock == 0 || currTrial/currBlock > numPerBlock) || (currTrial == 100 && mod(i,3) == 0) )
                    if( currBlock ~= 0 )
                        if(currSID == 90)
                            disp(currBlock)
                            disp(currTrial)
                        end
                        trialStart = (i-(numPerBlock*3));
                        if( ((i-startInd)/3) == 99 )
                            tempMat = edaMat(trialStart+3:i-1,:);
                            tempSkipVec = skipVec(trialStart+3:i-1);
                            tempRewLoss = rewLossVec(trialStart+3:i-1);
                        else
                            tempMat = edaMat(trialStart:i-1,:);
                            tempSkipVec = skipVec(trialStart:i-1);
                            tempRewLoss = rewLossVec(trialStart:i-1);
                        end
                        tempMat = tempMat(~tempSkipVec, :);
                        %(i-(numBlocks*3+1))
                        %(i-startInd+1)/3
                        tempRewLoss = tempRewLoss(~tempSkipVec);
                        antic = tempMat(tempMat(:,4) == 1 | tempMat(:,4) == 4, 5:end);
                        rewLossAnticInd = tempRewLoss(tempMat(:,4) == 1 | tempMat(:,4) == 4);
                        anticRew = antic(~rewLossAnticInd,:);
                        if( isempty(anticRew) )
                            anticRew = nan(1,8);
                        end
                        anticLoss = antic(logical(rewLossAnticInd),:);
                        if( isempty(anticLoss) )
                            anticLoss = nan(1,8);
                        end

                        deck = tempMat(tempMat(:,4) == 2 | tempMat(:,4) == 5, 5:end);
                        rewLossDeckInd = tempRewLoss(tempMat(:,4) == 2 | tempMat(:,4) == 5);
                        deckRew = deck(~rewLossDeckInd,:);
                        if( isempty(deckRew) )
                            deckRew = nan(1,8);
                        end
                        deckLoss = deck(logical(rewLossDeckInd),:);
                        if( isempty(deckLoss) )
                            deckLoss = nan(1,8);
                        end

                        rewloss = tempMat(tempMat(:,4) == 3 | tempMat(:,4) == 6, 5:end);
                        rewLossRewLossInd = tempRewLoss(tempMat(:,4) == 3 | tempMat(:,4) == 6);
                        rewlossRew = rewloss(~rewLossRewLossInd,:);
                        if( isempty(rewlossRew) )
                            rewlossRew = nan(1,8);
                        end
                        rewlossLoss = rewloss(logical(rewLossRewLossInd),:);
                        if( isempty(rewlossLoss) )
                            rewlossLoss = nan(1,8);
                        end


                        tempMatGood = tempMat(tempMat(:,4) == 4 | tempMat(:,4) == 5 | tempMat(:,4) == 6,:);
                        rewLossGoodInd = tempRewLoss(tempMat(:,4) == 4 | tempMat(:,4) == 5 | tempMat(:,4) == 6);

                        if( ~isempty(tempMatGood))
                            tempMatGoodAntic = tempMatGood(tempMatGood(:,4) == 4,5:end);
                            tempMatGoodDeck = tempMatGood(tempMatGood(:,4) == 5,5:end);
                            tempMatGoodRewLoss = tempMatGood(tempMatGood(:,4) == 6,5:end);

                            %Now get "reward" and "loss" trials
                            tempMatGoodRew = tempMatGood(~rewLossGoodInd,:);
                            if( ~isempty(tempMatGoodRew) )
                                tempMatGoodAnticRew = tempMatGood(tempMatGoodRew(:,4) == 4,5:end);
                                tempMatGoodDeckRew = tempMatGood(tempMatGoodRew(:,4) == 5,5:end);
                                tempMatGoodRewLossRew = tempMatGood(tempMatGoodRew(:,4) == 6,5:end);
                            else
                                tempMatGoodAnticRew = nan(1,8);
                                tempMatGoodDeckRew = nan(1,8);
                                tempMatGoodRewLossRew = nan(1,8);
                            end

                            tempMatGoodLoss = tempMatGood(logical(rewLossGoodInd),:);

                            if( ~isempty(tempMatGoodLoss) )
                                tempMatGoodAnticLoss = tempMatGood(tempMatGoodLoss(:,4) == 4,5:end);
                                tempMatGoodDeckLoss = tempMatGood(tempMatGoodLoss(:,4) == 5,5:end);
                                tempMatGoodRewLossLoss = tempMatGood(tempMatGoodLoss(:,4) == 6,5:end);
                            else
                                tempMatGoodAnticLoss = nan(1,8);
                                tempMatGoodDeckLoss = nan(1,8);
                                tempMatGoodRewLossLoss = nan(1,8);
                            end
                        else
                            tempMatGoodAntic = nan(1,8);
                            tempMatGoodDeck = nan(1,8);
                            tempMatGoodRewLoss = nan(1,8);
                            tempMatGoodAnticRew = nan(1,8);
                            tempMatGoodAnticLoss = nan(1,8);
                            tempMatGoodDeckRew = nan(1,8);
                            tempMatGoodDeckLoss = nan(1,8);
                            tempMatGoodRewLossRew = nan(1,8);
                            tempMatGoodRewLossLoss = nan(1,8);
                        end

                        tempMatBad = tempMat(tempMat(:,4) == 1 | tempMat(:,4) == 2 | tempMat(:,4) == 3,:);
                        rewLossBadInd = tempRewLoss(tempMat(:,4) == 1 | tempMat(:,4) == 2 | tempMat(:,4) == 3);

                        if( ~isempty(tempMatBad))
                            tempMatBadAntic = tempMatBad(tempMatBad(:,4) == 1,5:end);
                            tempMatBadDeck = tempMatBad(tempMatBad(:,4) == 2,5:end);
                            tempMatBadRewLoss = tempMatBad(tempMatBad(:,4) == 3,5:end);

                            %Now get "reward" and "loss" trials
                            tempMatBadRew = tempMatBad(~rewLossBadInd,:);
                            if( ~isempty(tempMatBadRew) )
                                tempMatBadAnticRew = tempMatBad(tempMatBadRew(:,4) == 1,5:end);
                                tempMatBadDeckRew = tempMatBad(tempMatBadRew(:,4) == 2,5:end);
                                tempMatBadRewLossRew = tempMatBad(tempMatBadRew(:,4) == 3,5:end);
                            else
                                tempMatBadAnticRew = nan(1,8);
                                tempMatBadDeckRew = nan(1,8);
                                tempMatBadRewLossRew = nan(1,8);
                            end

                            tempMatBadLoss = tempMatBad(logical(rewLossBadInd),:);
                            if( ~isempty(tempMatBadLoss) )
                                tempMatBadAnticLoss = tempMatBad(tempMatBadLoss(:,4) == 1,5:end);
                                tempMatBadDeckLoss = tempMatBad(tempMatBadLoss(:,4) == 2,5:end);
                                tempMatBadRewLossLoss = tempMatBad(tempMatBadLoss(:,4) == 3,5:end);
                            else
                                tempMatBadAnticLoss = nan(1,8);
                                tempMatBadDeckLoss = nan(1,8);
                                tempMatBadRewLossLoss = nan(1,8);
                            end
                        else
                            tempMatBadAntic = nan(1,8);
                            tempMatBadDeck = nan(1,8);
                            tempMatBadRewLoss = nan(1,8);
                            tempMatBadAnticRew = nan(1,8);
                            tempMatBadAnticLoss = nan(1,8);
                            tempMatBadDeckRew = nan(1,8);
                            tempMatBadDeckLoss = nan(1,8);
                            tempMatBadRewLossRew = nan(1,8);
                            tempMatBadRewLossLoss = nan(1,8);

                        end

                        nanmean(tempMatGoodDeck, 1);
                        nanmean(tempMatBadDeck, 1);

                        %Fill in new block matrix row w/ values
                        newEDABlockMat = ...
                            [newEDABlockMat; [currSID, currSex, currGroup, currBlock, ...
                            nanmean(antic, 1), nanmean(deck, 1), ...
                            nanmean(rewloss, 1), nanmean(tempMatBadAntic, 1), ...
                            nanmean(tempMatBadDeck, 1), nanmean(tempMatBadRewLoss, 1), ...
                            nanmean(tempMatGoodAntic, 1), nanmean(tempMatGoodDeck, 1), ...
                            nanmean(tempMatGoodRewLoss, 1), log(nanmean(antic(:,1), 1)), ...
                            log(nanmean(deck(:,1), 1)), log(nanmean(rewloss(:,1), 1)), ...
                            log(nanmean(tempMatBadAntic(:,1), 1)), log(nanmean(tempMatBadDeck(:,1), 1)), ...
                            log(nanmean(tempMatBadRewLoss(:,1), 1)), log(nanmean(tempMatGoodAntic(:,1), 1)), ...
                            log(nanmean(tempMatGoodDeck(:,1), 1)), log(nanmean(tempMatGoodRewLoss(:,1), 1)), ...
                            nanmean(anticRew, 1), nanmean(deckRew, 1), ...
                            nanmean(rewlossRew, 1), nanmean(tempMatBadAnticRew, 1), ...
                            nanmean(tempMatBadDeckRew, 1), nanmean(tempMatBadRewLossRew, 1),...
                            nanmean(tempMatGoodAnticRew, 1), nanmean(tempMatGoodDeckRew, 1), ...
                            nanmean(tempMatGoodRewLossRew, 1), log(nanmean(anticRew(:,1), 1)), ...
                            log(nanmean(deckRew(:,1), 1)), log(nanmean(rewlossRew(:,1), 1)), ...
                            log(nanmean(tempMatBadAnticRew(:,1), 1)), ...
                            log(nanmean(tempMatBadDeckRew(:,1), 1)), log(nanmean(tempMatBadRewLossRew(:,1), 1)), ...
                            log(nanmean(tempMatGoodAnticRew(:,1), 1)), log(nanmean(tempMatGoodDeckRew(:,1), 1)),...
                            log(nanmean(tempMatGoodRewLossRew(:,1), 1)), ...
                            nanmean(anticLoss, 1), nanmean(deckLoss, 1), nanmean(rewlossLoss, 1), ...
                            nanmean(tempMatBadAnticLoss, 1), ...
                            nanmean(tempMatBadDeckLoss, 1), nanmean(tempMatBadRewLossLoss, 1), ...
                            nanmean(tempMatGoodAnticLoss, 1), nanmean(tempMatGoodDeckLoss, 1), ...
                            nanmean(tempMatGoodRewLossLoss, 1), log(nanmean(anticLoss(:,1), 1)), ...
                            log(nanmean(deckLoss(:,1), 1)), log(nanmean(rewlossLoss(:,1), 1)), ...
                            log(nanmean(tempMatBadAnticLoss(:,1), 1)), ...
                            log(nanmean(tempMatBadDeckLoss(:,1), 1)), log(nanmean(tempMatBadRewLossLoss(:,1), 1)), ...
                            log(nanmean(tempMatGoodAnticLoss(:,1), 1)), log(nanmean(tempMatGoodDeckLoss(:,1), 1)), ...
                            log(nanmean(tempMatGoodRewLossLoss(:,1), 1))]];
                    end
                    if( currTrial ~= 100 )
                        currBlock = currBlock + 1;
                    end
                end
                continue;
            end
        end
        
        %If we're starting a new trial (every 3 cells)
        if( mod(i, 3) == 0 )
            if( currTrial ~= 0 )
                %Check Behavioral File data to see if we are at a rewarding
                %or rewarding+loss trial
                trialLoss = losses(currTrial);
                
                if( trialLoss > 0 )
                    rewLossVec(i-3:i-1) = 1;
                end
            end
            currTrial = currTrial + 1;
        end
        
        %If we're at a new block
        if( mod(i, 3) == 0 && (currBlock == 0 || currTrial/currBlock > numPerBlock || currTrial == 100))
            if( currBlock ~= 0 )
                if(currSID == 90)
                    disp(currBlock)
                    disp(currTrial)
                end
                trialStart = (i-(numPerBlock*3));
                if( ((i-startInd)/3) == 99 )
                    tempMat = edaMat(trialStart+3:i-1,:);
                    tempSkipVec = skipVec(trialStart+3:i-1);
                    tempRewLoss = rewLossVec(trialStart+3:i-1);
                else
                    tempMat = edaMat(trialStart:i-1,:);
                    tempSkipVec = skipVec(trialStart:i-1);
                    tempRewLoss = rewLossVec(trialStart:i-1);
                end
                tempMat = tempMat(~tempSkipVec, :);
                tempRewLoss = tempRewLoss(~tempSkipVec);
                antic = tempMat(tempMat(:,4) == 1 | tempMat(:,4) == 4, 5:end);
                rewLossAnticInd = tempRewLoss(tempMat(:,4) == 1 | tempMat(:,4) == 4);
                anticRew = antic(~rewLossAnticInd,:);
                if( isempty(anticRew) )
                    anticRew = nan(1,8);
                end
                anticLoss = antic(logical(rewLossAnticInd),:);
                if( isempty(anticLoss) )
                    anticLoss = nan(1,8);
                end
                
                deck = tempMat(tempMat(:,4) == 2 | tempMat(:,4) == 5, 5:end);
                rewLossDeckInd = tempRewLoss(tempMat(:,4) == 2 | tempMat(:,4) == 5);
                deckRew = deck(~rewLossDeckInd,:);
                if( isempty(deckRew) )
                    deckRew = nan(1,8);
                end
                deckLoss = deck(logical(rewLossDeckInd),:);
                if( isempty(deckLoss) )
                    deckLoss = nan(1,8);
                end
                
                rewloss = tempMat(tempMat(:,4) == 3 | tempMat(:,4) == 6, 5:end);
                rewLossRewLossInd = tempRewLoss(tempMat(:,4) == 3 | tempMat(:,4) == 6);
                rewlossRew = rewloss(~rewLossRewLossInd,:);
                if( isempty(rewlossRew) )
                    rewlossRew = nan(1,8);
                end
                rewlossLoss = rewloss(logical(rewLossRewLossInd),:);
                if( isempty(rewlossLoss) )
                    rewlossLoss = nan(1,8);
                end
                
                
                tempMatGood = tempMat(tempMat(:,4) == 4 | tempMat(:,4) == 5 | tempMat(:,4) == 6,:);
                rewLossGoodInd = tempRewLoss(tempMat(:,4) == 4 | tempMat(:,4) == 5 | tempMat(:,4) == 6);
                
                if( ~isempty(tempMatGood))
                    tempMatGoodAntic = tempMatGood(tempMatGood(:,4) == 4,5:end);
                    tempMatGoodDeck = tempMatGood(tempMatGood(:,4) == 5,5:end);
                    tempMatGoodRewLoss = tempMatGood(tempMatGood(:,4) == 6,5:end);
                    
                    %Now get "reward" and "loss" trials
                    tempMatGoodRew = tempMatGood(~rewLossGoodInd,:);
                    if( ~isempty(tempMatGoodRew) )
                        tempMatGoodAnticRew = tempMatGood(tempMatGoodRew(:,4) == 4,5:end);
                        tempMatGoodDeckRew = tempMatGood(tempMatGoodRew(:,4) == 5,5:end);
                        tempMatGoodRewLossRew = tempMatGood(tempMatGoodRew(:,4) == 6,5:end);
                    else
                        tempMatGoodAnticRew = nan(1,8);
                        tempMatGoodDeckRew = nan(1,8);
                        tempMatGoodRewLossRew = nan(1,8);
                    end
                    
                    tempMatGoodLoss = tempMatGood(logical(rewLossGoodInd),:);
                    
                    if( ~isempty(tempMatGoodLoss) )
                        tempMatGoodAnticLoss = tempMatGood(tempMatGoodLoss(:,4) == 4,5:end);
                        tempMatGoodDeckLoss = tempMatGood(tempMatGoodLoss(:,4) == 5,5:end);
                        tempMatGoodRewLossLoss = tempMatGood(tempMatGoodLoss(:,4) == 6,5:end);
                    else
                        tempMatGoodAnticLoss = nan(1,8);
                        tempMatGoodDeckLoss = nan(1,8);
                        tempMatGoodRewLossLoss = nan(1,8);
                    end
                else
                    tempMatGoodAntic = nan(1,8);
                    tempMatGoodDeck = nan(1,8);
                    tempMatGoodRewLoss = nan(1,8);
                    tempMatGoodAnticRew = nan(1,8);
                    tempMatGoodAnticLoss = nan(1,8);
                    tempMatGoodDeckRew = nan(1,8);
                    tempMatGoodDeckLoss = nan(1,8);
                    tempMatGoodRewLossRew = nan(1,8);
                    tempMatGoodRewLossLoss = nan(1,8);
                end
                
                tempMatBad = tempMat(tempMat(:,4) == 1 | tempMat(:,4) == 2 | tempMat(:,4) == 3,:);
                rewLossBadInd = tempRewLoss(tempMat(:,4) == 1 | tempMat(:,4) == 2 | tempMat(:,4) == 3);
                
                if( ~isempty(tempMatBad))
                    tempMatBadAntic = tempMatBad(tempMatBad(:,4) == 1,5:end);
                    tempMatBadDeck = tempMatBad(tempMatBad(:,4) == 2,5:end);
                    tempMatBadRewLoss = tempMatBad(tempMatBad(:,4) == 3,5:end);
                    
                    %Now get "reward" and "loss" trials
                    tempMatBadRew = tempMatBad(~rewLossBadInd,:);
                    if( ~isempty(tempMatBadRew) )
                        tempMatBadAnticRew = tempMatBad(tempMatBadRew(:,4) == 1,5:end);
                        tempMatBadDeckRew = tempMatBad(tempMatBadRew(:,4) == 2,5:end);
                        tempMatBadRewLossRew = tempMatBad(tempMatBadRew(:,4) == 3,5:end);
                    else
                        tempMatBadAnticRew = nan(1,8);
                        tempMatBadDeckRew = nan(1,8);
                        tempMatBadRewLossRew = nan(1,8);
                    end
                    
                    tempMatBadLoss = tempMatBad(logical(rewLossBadInd),:);
                    if( ~isempty(tempMatBadLoss) )
                        tempMatBadAnticLoss = tempMatBad(tempMatBadLoss(:,4) == 1,5:end);
                        tempMatBadDeckLoss = tempMatBad(tempMatBadLoss(:,4) == 2,5:end);
                        tempMatBadRewLossLoss = tempMatBad(tempMatBadLoss(:,4) == 3,5:end);
                    else
                        tempMatBadAnticLoss = nan(1,8);
                        tempMatBadDeckLoss = nan(1,8);
                        tempMatBadRewLossLoss = nan(1,8);
                    end
                else
                    tempMatBadAntic = nan(1,8);
                    tempMatBadDeck = nan(1,8);
                    tempMatBadRewLoss = nan(1,8);
                    tempMatBadAnticRew = nan(1,8);
                    tempMatBadAnticLoss = nan(1,8);
                    tempMatBadDeckRew = nan(1,8);
                    tempMatBadDeckLoss = nan(1,8);
                    tempMatBadRewLossRew = nan(1,8);
                    tempMatBadRewLossLoss = nan(1,8);
                    
                end
                
                nanmean(tempMatGoodDeck, 1);
                nanmean(tempMatBadDeck, 1);
                
                %Fill in new block matrix row w/ values
                newEDABlockMat = ...
                    [newEDABlockMat; [currSID, currSex, currGroup, currBlock, ...
                    nanmean(antic, 1), nanmean(deck, 1), ...
                    nanmean(rewloss, 1), nanmean(tempMatBadAntic, 1), ...
                    nanmean(tempMatBadDeck, 1), nanmean(tempMatBadRewLoss, 1), ...
                    nanmean(tempMatGoodAntic, 1), nanmean(tempMatGoodDeck, 1), ...
                    nanmean(tempMatGoodRewLoss, 1), log(nanmean(antic(:,1), 1)), ...
                    log(nanmean(deck(:,1), 1)), log(nanmean(rewloss(:,1), 1)), ...
                    log(nanmean(tempMatBadAntic(:,1), 1)), log(nanmean(tempMatBadDeck(:,1), 1)), ...
                    log(nanmean(tempMatBadRewLoss(:,1), 1)), log(nanmean(tempMatGoodAntic(:,1), 1)), ...
                    log(nanmean(tempMatGoodDeck(:,1), 1)), log(nanmean(tempMatGoodRewLoss(:,1), 1)), ...
                    nanmean(anticRew, 1), nanmean(deckRew, 1), ...
                    nanmean(rewlossRew, 1), nanmean(tempMatBadAnticRew, 1), ...
                    nanmean(tempMatBadDeckRew, 1), nanmean(tempMatBadRewLossRew, 1),...
                    nanmean(tempMatGoodAnticRew, 1), nanmean(tempMatGoodDeckRew, 1), ...
                    nanmean(tempMatGoodRewLossRew, 1), log(nanmean(anticRew(:,1), 1)), ...
                    log(nanmean(deckRew(:,1), 1)), log(nanmean(rewlossRew(:,1), 1)), ...
                    log(nanmean(tempMatBadAnticRew(:,1), 1)), ...
                    log(nanmean(tempMatBadDeckRew(:,1), 1)), log(nanmean(tempMatBadRewLossRew(:,1), 1)), ...
                    log(nanmean(tempMatGoodAnticRew(:,1), 1)), log(nanmean(tempMatGoodDeckRew(:,1), 1)),...
                    log(nanmean(tempMatGoodRewLossRew(:,1), 1)), ...
                    nanmean(anticLoss, 1), nanmean(deckLoss, 1), nanmean(rewlossLoss, 1), ...
                    nanmean(tempMatBadAnticLoss, 1), ...
                    nanmean(tempMatBadDeckLoss, 1), nanmean(tempMatBadRewLossLoss, 1), ...
                    nanmean(tempMatGoodAnticLoss, 1), nanmean(tempMatGoodDeckLoss, 1), ...
                    nanmean(tempMatGoodRewLossLoss, 1), log(nanmean(anticLoss(:,1), 1)), ...
                    log(nanmean(deckLoss(:,1), 1)), log(nanmean(rewlossLoss(:,1), 1)), ...
                    log(nanmean(tempMatBadAnticLoss(:,1), 1)), ...
                    log(nanmean(tempMatBadDeckLoss(:,1), 1)), log(nanmean(tempMatBadRewLossLoss(:,1), 1)), ...
                    log(nanmean(tempMatGoodAnticLoss(:,1), 1)), log(nanmean(tempMatGoodDeckLoss(:,1), 1)), ...
                    log(nanmean(tempMatGoodRewLossLoss(:,1), 1))]];
            end
            if( currTrial ~= 100 )
                currBlock = currBlock + 1;
            end
        end
    end
    
    csvwrite(fullfile(dirName, strcat('Block-',newFileName)), newEDABlockMat);
%     csvwrite(fullfile(dirName, strcat('Trial-',newFileName)), newEDATrialMat);
end

