function varargout = start_up(varargin)
% START_UP MATLAB code for start_up.fig
%      START_UP, by itself, creates a new START_UP or raises the existing
%      singleton*.
%
%      H = START_UP returns the handle to a new START_UP or the handle to
%      the existing singleton*.
%
%      START_UP('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in START_UP.M with the given input arguments.
%
%      START_UP('Property','Value',...) creates a new START_UP or raises
%      the existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before start_up_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to start_up_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help start_up

% Last Modified by GUIDE v2.5 31-Dec-2015 16:06:12

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @start_up_OpeningFcn, ...
                   'gui_OutputFcn',  @start_up_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT



% --- Executes just before start_up is made visible.
function start_up_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to start_up (see VARARGIN)

% Choose default command line output for start_up
handles.output = hObject;

handles.group = 1;
handles.sid = 999;
handles.mORf = 'm';
handles.penaltyFunStr = 'PenaltyDist';
handles.igtHomeDir = '.';
handles.savePath = '.';
handles.imageDir = 'images';
handles.breaksLength = [4,3.5,3.5,0];
handles.comPort = 0;
handles.simulation = 0;
handles.numTrials = 100;

% Update handles structure
guidata(hObject, handles);

initialize_gui(hObject, handles, false);

% UIWAIT makes start_up wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = start_up_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes during object creation, after setting all properties.
function sid_CreateFcn(hObject, eventdata, handles)
% hObject    handle to sid (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function sid_Callback(hObject, eventdata, handles)
% hObject    handle to sid (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of sid as text
%        str2double(get(hObject,'String')) returns contents of sid as a double
 
 handles.sid = str2double(get(hObject, 'String'));
 if isnan(handles.sid)
     set(hObject, 'String', 999);
     errordlg('Input must be a number','Error');
 end

% --- Executes on button press in runIGT.
function runIGT_Callback(hObject, eventdata, handles)
% hObject    handle to runIGT (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
 delete(handles.figure1)
try
 igt_open(handles.group, handles.sid, handles.numTrials, ...
           handles.savePath, handles.mORf, handles.penaltyFunStr, ...
           handles.igtHomeDir, handles.imageDir, handles.breaksLength, ...
           handles.comPort, handles.simulation)
catch ME
    Screen('CloseAll')
    ME.stack.line
end

% --- Executes on button press in reset.
function reset_Callback(hObject, eventdata, handles)
% hObject    handle to reset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
 %quick fix to reset GUI (close & open it up again), may want to make this
 % more efficient in the future
 delete(handles.figure1)
 start_up()
 
 
% --------------------------------------------------------------------
function initialize_gui(fig_handle, handles, isreset)
% If the metricdata field is present and the reset flag is false, it means
% we are we are just re-initializing a GUI by calling it from the cmd line
% while it is up. So, bail out as we dont want to reset the data.
if ~isreset
    return;
end

% Update handles structure
 guidata(handles.figure1, handles);



function group_Callback(hObject, eventdata, handles)
% hObject    handle to group (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of group as text
%        str2double(get(hObject,'String')) returns contents of group as a double
 
 handles.group = str2num(get(hObject, 'String'));
 guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function group_CreateFcn(hObject, eventdata, handles)
% hObject    handle to group (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in mORf.
function mORf_Callback(hObject, eventdata, handles)
% hObject    handle to mORf (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns mORf contents as cell array
%        contents{get(hObject,'Value')} returns selected item from mORf
 
 contents = cellstr(get(hObject,'String'));
 handles.mORf = contents{get(hObject, 'Value')};
 guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function mORf_CreateFcn(hObject, eventdata, handles)
% hObject    handle to mORf (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in penaltyFunStr.
function penaltyFunStr_Callback(hObject, eventdata, handles)
% hObject    handle to penaltyFunStr (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
 
 handles.penaltyFunStr = get(hObject, 'String');
 guidata(hObject, handles);



% --- Executes during object creation, after setting all properties.
function penaltyFunStr_CreateFcn(hObject, eventdata, handles)
% hObject    handle to penaltyFunStr (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function dPLength_Callback(hObject, eventdata, handles)
% hObject    handle to dPLength (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of dPLength as text
%        str2double(get(hObject,'String')) returns contents of dPLength as a double
 
 handles.breaksLength(1) = str2double(get(hObject, 'String'));
 guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function dPLength_CreateFcn(hObject, eventdata, handles)
% hObject    handle to dPLength (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function rlPLength_Callback(hObject, eventdata, handles)
% hObject    handle to rlPLength (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of rlPLength as text
%        str2double(get(hObject,'String')) returns contents of rlPLength as a double
 
 handles.breaksLength(2) = str2double(get(hObject, 'String'));
 guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function rlPLength_CreateFcn(hObject, eventdata, handles)
% hObject    handle to rlPLength (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function tBLength_Callback(hObject, eventdata, handles)
% hObject    handle to tBLength (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of tBLength as text
%        str2double(get(hObject,'String')) returns contents of tBLength as a double
 
 handles.breaksLength(3) = str2double(get(hObject, 'String'));
 guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function tBLength_CreateFcn(hObject, eventdata, handles)
% hObject    handle to tBLength (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function sPLength_Callback(hObject, eventdata, handles)
% hObject    handle to sPLength (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of sPLength as text
%        str2double(get(hObject,'String')) returns contents of sPLength as a double
 
 handles.breaksLength(4) = str2double(get(hObject, 'String'));
 guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function sPLength_CreateFcn(hObject, eventdata, handles)
% hObject    handle to sPLength (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function simulation_Callback(hObject, eventdata, handles)
% hObject    handle to simulation (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of simulation as text
%        str2double(get(hObject,'String')) returns contents of simulation as a double
 
 contents = cellstr(get(hObject,'String'));
 handles.simulation = contents{get(hObject, 'Value')};
 guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function simulation_CreateFcn(hObject, eventdata, handles)
% hObject    handle to simulation (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit16_Callback(hObject, eventdata, handles)
% hObject    handle to simulation (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of simulation as text
%        str2double(get(hObject,'String')) returns contents of simulation as a double


% --- Executes during object creation, after setting all properties.
function edit16_CreateFcn(hObject, eventdata, handles)
% hObject    handle to simulation (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function numTrials_Callback(hObject, eventdata, handles)
% hObject    handle to numTrials (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of numTrials as text
%        str2double(get(hObject,'String')) returns contents of numTrials as a double
 
 handles.numTrials = str2double(get(hObject, 'String'));
 guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function numTrials_CreateFcn(hObject, eventdata, handles)
% hObject    handle to numTrials (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in igtHomeDir.
function igtHomeDir_Callback(hObject, eventdata, handles)
% hObject    handle to igtHomeDir (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
 
 handles.igtHomeDir = uigetdir();
 guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function igtHomeDir_CreateFcn(hObject, eventdata, handles)
% hObject    handle to igtHomeDir (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes on button press in imageDir.
function imageDir_Callback(hObject, eventdata, handles)
% hObject    handle to imageDir (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
 
 handles.imageDir = uigetdir();
 guidata(hObject, handles);


% --- Executes on button press in savePath.
function savePath_Callback(hObject, eventdata, handles)
% hObject    handle to savePath (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
 
 handles.savePath = uigetdir();
 guidata(hObject, handles);

 function popupmenu1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to sPLength (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
